//+------------------------------------------------------------------+
//|                                      test_ArtrayPrint Unions.mq5 |
//|                                                            Calli |
//|                              https://www.mql5.com/de/users/gooly |
//+------------------------------------------------------------------+
#property copyright "Calli"
#property link      "https://www.mql5.com/de/users/gooly"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
#define _u0  0
#define _u1  1
#define _u2  2
#define _u3  3
#define _u4  4
#define _u5  5
#define _u6  6
#define _u7  7
#define _u8  8

union _uTest{
 double p;
 ulong  id;
} uTest[][9];

void fillUnion(int n){
   while(n-->0) {
      int sz = ArrayRange(uTest,0);
      ArrayResize(uTest,sz+1);
      uTest[sz][_u0].id = n;
      uTest[sz][_u1].id = __LINE__;
      uTest[sz][_u2].id = __LINE__;
      uTest[sz][_u3].p  = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
      uTest[sz][_u4].p  = SymbolInfoDouble(_Symbol,SYMBOL_BID);
      uTest[sz][_u5].p  = SymbolInfoDouble(_Symbol,SYMBOL_ASKHIGH);
      uTest[sz][_u6].p  = SymbolInfoDouble(_Symbol,SYMBOL_BIDLOW);
      uTest[sz][_u7].id = __LINE__;
      uTest[sz][_u8].id = __LINE__;
   }
}

void OnStart()
  {
//---
      fillUnion(10);
      // ArraySort(uTest); //<= fails in this script :(
      ArrayReverse(uTest);
      
      ArrayPrint(uTest); // the second item of the array is printed in 1st place [0,0] while the first one oved to the end as [9,8]
   
  }
//+------------------------------------------------------------------+
